<?php
defined('_JEXEC') or die('Restricted access');
jimport('joomla.plugin.plugin');

class plgRedshop_paymentrs_payment_cashbill extends JPlugin
{
    public $_table_prefix = null;
    
    public function plgRedshop_paymentrs_payment_cashbill(&$subject)
    {
        parent::__construct($subject);
        $this->_table_prefix = '#__redshop_';
        $this->_plugin = JPluginHelper::getPlugin('redshop_payment', 'rs_payment_cashbill');
        $this->_params = new JRegistry($this->_plugin->params);
    }
    
    public function onPrePayment($element, $data)
    {
        if ($element != 'rs_payment_cashbill')
        {
            return;
        }
        
        if (empty($plugin))
        {
            $plugin = $element;
        }
    
        $app = JFactory::getApplication();
        $paymentpath = JPATH_SITE . '/plugins/redshop_payment/' . $plugin . '/' . $plugin . '/form_template.php';
        include $paymentpath;
    }
    
    public function onNotifyPaymentrs_payment_cashbill($element, $request)
    {
        if ($element != 'rs_payment_cashbill')
        {
            return;
        }
        JPlugin::loadLanguage( 'com_redshop' );
        $parameter = $this->getparameters('rs_payment_cashbill');
        $paymentinfo = $parameter[0];
        $paymentparams = new JParameter( $paymentinfo->params );        
        
        if(isset($_POST['service']))
        {
        $cashbill_userkey = $paymentparams->get('cashbill_userkey','');
            if(md5($_POST['service'].$_POST['orderid'].$_POST['amount'].$_POST['userdata'].$_POST['status'].$cashbill_userkey) == $_POST['sign'])
            {
        
             $verify_status = $paymentparams->get('verify_status','');
             $invalid_status = $paymentparams->get('invalid_status','');
             $order_id = $_POST['userdata'];
             $values = new stdClass();
        
             $objOrder = new order_functions;
             $paymentResponse = new stdClass();
             
             $paymentResponse->order_id = $_POST['userdata'];
             $paymentResponse->transaction_id= $_POST['orderid'];
             if(strtoupper($_POST['status']) == 'OK')
             {
                 $paymentResponse->log = 'Płatność została przyjęta na kwotę '.$_POST['amount'].' PLN przez CashBill';
                 $paymentResponse->msg = 'Powiadomienie CashBill';
                 $paymentResponse->order_status_code = $verify_status;
                 $paymentResponse->order_payment_status_code = 'Paid';
             }else
             {
                 $paymentResponse->log = 'Nie przyjęto płatności. CashBill ID : '.$_POST['orderid'];
                 $paymentResponse->msg = 'Powiadomienie CashBill';
                 $paymentResponse->order_status_code = $invalid_status;
                 $paymentResponse->order_payment_status_code = 'UnPaid';
             }
             $objOrder->changeorderstatus($paymentResponse);
             ob_clean();
             echo 'OK'; 
             exit();
            }
            ob_clean();
            echo 'BLAD SYGNATURY';
            exit();
        }
        
        $paymentResponse = new stdClass();
        $paymentResponse->order_id = $_GET['userdata'];
        if(strtoupper($_GET['status']) == 'OK')
        {
            $paymentResponse->msg = 'Twoja wpłata została zaksięgowana. ';
        }else
        {
            $paymentResponse->msg = 'Twoja wpłata nie została zaksięgowana. ';
        }
            
        $paymentResponse->msg .= 'Dziękujemy za skorzystanie z płatności CashBill';
        return $paymentResponse;

    }
    
    public function getParameters($payment)
    {
        $db = JFactory::getDbo();
        $sql = "SELECT * FROM #__extensions WHERE `element`='" . $payment . "'";
        $db->setQuery($sql);
        $params = $db->loadObjectList();
    
        return $params;
    }
    
    public function orderPaymentNotYetUpdated($dbConn, $order_id, $tid)
    {
        $db = JFactory::getDbo();
        $res = false;
        $query = "SELECT COUNT(*) `qty` FROM `#__redshop_order_payment` WHERE `order_id` = '"
            . $db->getEscaped($order_id) . "' and order_payment_trans_id = '" . $db->getEscaped($tid) . "'";
        $db->setQuery($query);
        $order_payment = $db->loadResult();
    
        if ($order_payment == 0)
        {
            $res = true;
        }
    
        return $res;
    }
    
    

}